/*
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.0 of the PHP license,       |
   | that is bundled with this package in the file LICENSE, and is        |
   | available at through the world-wide-web at                           |
   | http://www.php.net/license/2_02.txt.                                 |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
   | Authors:  Hartmut Holzgraefe <hartmut@php.net>                       |
   +----------------------------------------------------------------------+
*/

/* $ Id: $ */ 

#ifndef PHP_HTML_PARSE_H
#define PHP_HTML_PARSE_H


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_HTML_PARSE

#include <php.h>
#include <php_ini.h>
#include <SAPI.h>
#include <ext/standard/info.h>

#include <ekhtml.h>
/* resource payload for html_parse resources */
typedef struct {
  /* HTML parser */
	ekhtml_parser_t *parser;
  /* callback functions */
	zval *startElementHandler;
	zval *endElementHandler;
	zval *characterDataHandler;
	zval *commentHandler;
} php_html_parser;

extern zend_module_entry html_parse_module_entry;
#define phpext_html_parse_ptr &html_parse_module_entry

#ifdef PHP_WIN32
#define PHP_HTML_PARSE_API __declspec(dllexport)
#else
#define PHP_HTML_PARSE_API
#endif

PHP_MINIT_FUNCTION(html_parse);
PHP_MSHUTDOWN_FUNCTION(html_parse);
PHP_RINIT_FUNCTION(html_parse);
PHP_RSHUTDOWN_FUNCTION(html_parse);
PHP_MINFO_FUNCTION(html_parse);

#ifdef ZTS
#include "TSRM.h"
#endif


PHP_FUNCTION(html_parser_create);
PHP_FUNCTION(html_parser_free);
PHP_FUNCTION(html_parser_starttag_handler);
PHP_FUNCTION(html_parser_endtag_handler);
PHP_FUNCTION(html_parser_data_handler);
PHP_FUNCTION(html_parser_comment_handler);
PHP_FUNCTION(html_parser_parse);

#endif /* PHP_HAVE_HTML_PARSE */

#endif /* PHP_HTML_PARSE_H */


/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
